<?php session_start(); /* Starts the session */

if(!isset($_SESSION['UserData']['Username'])){
  header("location:login.php");
  exit;
}

// Load the config file which has the NSX Manager details along with the
// credentials required to access the NSX API.
require_once 'config.php';

// Defines a function so that we can verify only show commands are submitted
function startsWith($haystack, $needle) {
    // search backwards starting from haystack length characters from the end
    return $needle === "" || strrpos($haystack, $needle, -strlen($haystack)) !== FALSE;
}

// Check to see if a command has been submitted, and if it is a valid command
if( !empty($_POST['cli']) )
{
     $command = $_POST['cli'];

     // Debugging: Print the submitted command
     // print_r("<br>" .$command);
     $validCommand = startsWith($command, "show ");
}

// Check to see if a valid command has been submitted
if( $validCommand === true)
   {
        // Generate the XML to submit via the NSX Manager API
        $input_xml = '<nsxcli><command>'.$command.'</command></nsxcli>';

        // Debugging: Print the generated XML
        // print_r("<br><pre>" . htmlentities($input_xml) . "</pre>");

        // Debugging: Display that its a valid command that has been submitted
        // echo "Valid Command ";

        // Set the API URL
        $api_url = 'https://' . $nsxmgr . '/api/1.0/nsx/cli?action=execute';

        // Initialise a curl connection
        $curl = curl_init();

        // Set some options for how curl needs to behave
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
        curl_setopt($curl, CURLOPT_FAILONERROR, false);
        curl_setopt($curl, CURLOPT_URL, $api_url);
        curl_setopt($curl, CURLOPT_POST, true);
        curl_setopt($curl, CURLOPT_POSTFIELDS, $input_xml);
        curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($curl, CURLOPT_TIMEOUT, 10);

        // Execute the curl request
        $response = curl_exec($curl);
        // print_r($response);
        curl_close($curl);

        // If logging is enabled
        if ($logging === true)
        {
            // Open the logfile so it can be appended to and write stuff to it
            $file = fopen($logFile, 'a')  or die("Can't open fie webcentral.log. Please check permissions.");
            fwrite($file, "\n" . str_repeat("*",79));
            fwrite($file, "\nUSERNAME: " . $_SESSION['UserData']['Username']);
            fwrite($file, "\nTIMESTAMP: " . date("Y-m-d h:i:sa"));

            fwrite($file, "\nCOMMAND_API: " . $command);
            fwrite($file, "\n" . str_repeat("*",79));
            fwrite($file, "\nRESPONSE:\n\n" . $response);
            fclose($file);
        }
    }

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>NSX-v Web Central CLI</title>
    <link rel="stylesheet" type="text/css" href="style.css" />
  </head>

  <body>
    <img id="topSplash" src="img/AppBgPattern.png"/>
    <img id="brand" src="img/VMW_NSX_Logo-Black-Triangle-500w.png" />

    <div id="splashText">
      <h1>NSX-v Web Central CLI</h1>
      Welcome to the NSX vSphere Central Command Line Interface. From this page you can sumbit commands via the NSX-v Central CLI and view the output. Every effort has been made to limit the scope of the commands that can be issued to only "Central CLI commands".
      <br>
      <a href="logout.php">Logout</a><br>
    </div>

    <div id="input">
      <p/>
      <h4>
      Enter NSX Central CLI Commands below
      <?php
        if ($logging === true)
        {
            echo ' - Logging enabled.';
        }
      ?>
      </h4>
      <form method="post">
        <input type="text" name="cli" size="100" autofocus>
        <input type="submit" value="Submit" class="Button3">
        <input type="reset" value="Clear" class="Button4">
        <a href="helpfile.php" target="_BLANK"><img src="img/help-8.png" height="15"></a>
      </form>
      <br>
    </div>
    <div id="output">
      <?php
        print_r("<h4><pre>" . htmlentities($command) . "</pre></h4>");
        print_r("<pre>" . htmlentities($response) . "</pre>");
      ?>
    </div>
    <div align="center" class="demo">
      <a href="http://www.sneaku.com/" target="_blank">SneakU</a>
    </div>
  </body>
</html>
